/*************************************************************************** 
 *
 *                       u_cmd.c Version 3.25
 *
 *      Keyboard Command Processor for DSP-10 2-meter Transciever
 *
 *
 * NOTICE: Copyright (C) 1996 to 2001, 2004 by Robert S. Larkin
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * The program author can be contacted by email at boblark@proaxis.com.
 * Alternatively contact the author at
 *     Robert S. (Bob) Larkin
 *     2982 N. W. Acacia Place
 *     Corvallis, OR  97330  USA
 *
 * For more details on the background or use of the program, pay a visit to
 * http://www.proaxis.com/~boblark/dsp10.htm
 *
 * Ver 3.23 - Revised to bring keyboard settings from the configuration
 *     file. Changed from "case" to "if" to allow for non-constant
 *     expressions.  Put "k_" in front of each name to indicate key command.
 *     RSL 22 Sept 04.
 *
 ************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <graphics.h>
#include <string.h>
#include <time.h>
#include <dos.h>
#include <bios.h>
#include <process.h>
#include <direct.h>
#include "util.h"
#include "ustate.h"
/*  include "uhf_kbd.h" */
#include "u_code.h"
#include "async.h"
#include "moonsun.h"
#include "lbox.h"
#include "ufilter.h"
#include "uhfa.h"
#include "gifsave.h"

 int  do_cmd(void);
 void dtmf(int ichr);

int do_cmd(void)
	{
	unsigned int ichr, stat;
	unsigned int ch_cap;
 unsigned int achr;
	long lkey;
	int irtn;

	show_last_cmd("");

	stat = _bios_keybrd(_KEYBRD_SHIFTSTATUS);
	/* Make left and right shift keys equals (bits 0 and 1) and
	 * mask out Caps Lock, Num Lock and Insert (bits 5, 6, and 7).     */
	if (stat&2)   stat |= 1;
	stat &= 0X1D;
	ichr = _bios_keybrd(_KEYBRD_READ);
	ch_cap = ichr & 0X5F;		/* Drop high order and make caps */
 achr=ichr&0X7F;
	lkey = (long)ichr + (((long)stat)<<16);
	irtn=0;


#if 0
  if(mode==FM)
	{
	    if(ch_cap=='Q') {
			show_last_cmd("Tn Tog");
			if (ttn_control && 1) ttn_control = 4;  //Turn off
			else ttn_control |= 1;  /* Turn on */
			set_ttn(1);
			return(irtn); }
	}
#endif

	if(lkey==k_v2f_tog_c || lkey==k_v2f_tog_l )
		{
		if(!v2f_on) {
		    show_last_cmd("V2F ON");
		    v2f(1);
		    return irtn;}
		else {
		    show_last_cmd("V2FOFF");
		    v2f(3);
		    return irtn;}
		}
	if(lkey==k_v2f_res_c || lkey==k_v2f_res_l ) {
		show_last_cmd("V2FRes");
		if(v2f_on)  v2f(6);
		return irtn;}

	if(lkey==k_v2f_lbox_c || lkey==k_v2f_lbox_l ) {
		show_last_cmd("V2FBox");
		v2f_modalbox();
		return irtn;}

	if(lkey==k_mike_gain_m) {
			show_last_cmd("MIKE-");
			if (--mike_gain<0) mike_gain++;
			set_mike_gain();
			return(irtn); }
	if(lkey==k_mike_gain_p) {
			show_last_cmd("MIKE+");
			if (++mike_gain>100) mike_gain--;
			set_mike_gain();
			return(irtn); }
	if(lkey==k_xmt_power_m_l || lkey==k_xmt_power_m) {
			show_last_cmd("XPWR-");
			if (--xmit_power<0) xmit_power++;
			set_xmit_power();
			return(irtn); }
	if(lkey==k_xmt_power_p_l || lkey==k_xmt_power_p) {
			show_last_cmd("XPWR+");
			if (++xmit_power>100) xmit_power--;
			set_xmit_power();
			return(irtn); }
	if(lkey==k_cw_speed_m) {
			show_last_cmd("CW SP-");
			if (--cw_speed<0) cw_speed++;
			set_cw_speed();
			return(irtn); }
	if(lkey==k_cw_speed_p) {
			show_last_cmd("CW SP+");
			if (++cw_speed>25) cw_speed--;
			set_cw_speed();
			return(irtn); }
	if(lkey==k_t_r_tog) {
			show_last_cmd("T/R");
			if (mode==EME2)
			    {
			    if (eme_state ==-1) eme_state=4; /*Ready for xmit*/
			    else
				{
				eme_state=-1;	/* Not active */
				if(transmit) t_r_toggle();
				}
			    return(irtn);
			    }
			else
			    {
			    if (ptt) return(irtn); /* No response if ptt in xmit */
			    t_r_toggle();
			    return(irtn);
			    }
			}
	if(lkey==k_freq_m1) {
			show_last_cmd("FREQ-");
			if (mode != FM) tfreqL -= 1;
			new_freq();
			return(irtn); }
	if(lkey==k_freq_p1) {
			show_last_cmd("FREQ+");
			if (mode != FM) tfreqL += 1;
			new_freq();
			return(irtn); }
	if(lkey==k_freq_m10) {
			if (mode == FM)  tfreqL -= 5000;
			else tfreqL -= 10;
			new_freq();
			show_last_cmd("FREQ-");
			return(irtn); }
	if(lkey==k_freq_p10) {
			if (mode == FM)  tfreqL += 5000;
			else tfreqL += 10;
			new_freq();
			show_last_cmd("FREQ+");
			return(irtn); }
	if(lkey==k_freq_m100) {
			if (mode == FM)  tfreqL -= 5000;
			else tfreqL -= 100;
			new_freq();
			show_last_cmd("FREQ-");
			return(irtn); }
	if(lkey==k_freq_p100) {
			if (mode == FM)  tfreqL += 5000;
			else tfreqL += 100;
			new_freq();
			show_last_cmd("FREQ+");
			return(irtn); }
	if(lkey==k_freq_m1k) {
			show_last_cmd("FREQ-");
			if (mode == FM) tfreqL -= 5000;
			else tfreqL -= 1000;
			new_freq();
			return(irtn); }
	if(lkey==k_freq_p1k) {
			show_last_cmd("FREQ+");
			if (mode == FM) tfreqL += 5000;
			else tfreqL += 1000;
			new_freq();
			return(irtn); }
	if(lkey==k_freq_m10k) {
			show_last_cmd("FREQ-");
			tfreqL -= 10000;
			new_freq();
			return(irtn); }
	if(lkey==k_freq_p10k) {
			show_last_cmd("FREQ+");
			tfreqL += 10000;
			new_freq();
			return(irtn); }
	if(lkey==k_freq_m100k) {
			show_last_cmd("FREQ-");
			tfreqL -= 100000;
			new_freq();
			return(irtn); }
	if(lkey==k_freq_p100k) {
			show_last_cmd("FREQ+");
			tfreqL += 100000;
			new_freq();
			return(irtn); }
	if(lkey==k_freq_m1mhz) {
			show_last_cmd("FREQ-");
			tfreqL -= 1000000;
			new_freq();
			return(irtn); }
	if(lkey==k_freq_p1mhz) {
			show_last_cmd("FREQ+");
			tfreqL += 1000000;
			new_freq();
			return(irtn); }
	if(lkey==k_dfreqd) {
			show_last_cmd("FREQ-");
			tfreqL -= delf;
			new_freq();
			return(irtn); }
	if(lkey==k_dfrequ) {
			show_last_cmd("FREQ+");
			tfreqL += delf;
			new_freq();
			return(irtn); }
	if(lkey==k_sh_dfreqd) {
			show_last_cmd("FREQ-");
			tfreqL -= delf_sh;
			new_freq();
			return(irtn); }
	if(lkey==k_sh_dfrequ) {
			show_last_cmd("FREQ+");
			tfreqL += delf_sh;
			new_freq();
			return(irtn); }
	if(lkey==k_freq_box) {
			show_last_cmd("FREQ?");
			freq_box();
			return(irtn); }
	if(lkey==k_sidetone_lev_m_l || lkey==k_sidetone_lev_m) {
			show_last_cmd("STONE-");
			if (--sidetone_lev<0) sidetone_lev++;
			set_cwoffset();
			return(irtn); }
	if(lkey==k_sidetone_lev_p_l || lkey==k_sidetone_lev_p) {
			show_last_cmd("STONE+");
			if (++sidetone_lev>100) sidetone_lev--;
			set_cwoffset();
			return(irtn); }
	if(lkey==k_beacon_l || lkey==k_beacon_c) {
			show_last_cmd("BEACON");
			if (transmit) t_r_toggle();
			beacon ^= 1;

			show_beacon();
			if (beacon && mode==LTI && lt_b_clear>0)
			    {lterm_int_update(-1);	/* Zero sums */
			     paveave=0.0;
			     eme_pulse_count=0;
			    }
			if (beacon && (mode==CW || mode==LTI || mode==LHL7
				|| mode==PUA43) && bufcount==0)
					do_t_error(26, "W26 No Xmt Data", 500);
			return(irtn); }

	if(lkey==k_cas0) {
			show_last_cmd("Msg 0");
			put_morse(0);	
			return(irtn); }
	if(lkey==k_cas1) {
			show_last_cmd("Msg 1");
			put_morse(1);	
			return(irtn); }
	if(lkey==k_cas2) {
			show_last_cmd("Msg 2");
			put_morse(2);	
			return(irtn); }
	if(lkey==k_cas3) {
			show_last_cmd("Msg 3");
			put_morse(3);	
			return(irtn); }
	if(lkey==k_cas4) {
			show_last_cmd("Msg 4");
			put_morse(4);	
			return(irtn); }
	if(lkey==k_cas5) {
			show_last_cmd("Msg 5");
			put_morse(5);	
			return(irtn); }
	if(lkey==k_cas6) {
			show_last_cmd("Msg 6");
			put_morse(6);	
			return(irtn); }
	if(lkey==k_cas7) {
			show_last_cmd("Msg 7");
			put_morse(7);	
			return(irtn); }
	if(lkey==k_cas8) {
			show_last_cmd("Msg 8");
			put_morse(8);	
			return(irtn); }
	if(lkey==k_cas9) {
			show_last_cmd("Msg 9");
			put_morse(9);	
			return(irtn); }
	if(lkey==k_cw_buf_clr) {
			show_last_cmd("CLR BF");
			morse(INIT_CW, 0);
			if (mode==CW || mode==LTI)
			    print_medium(0, -1);
			else if (mode==LHL7 || mode==PUA43)
			    print_medium_1(0, -1);
			return(irtn); }

	/* Be careful that any key in the following must NOT also be above */
	if (transmit==0)		/* Keys available only in receive */
	    {
	    if(lkey==k_help) {
			show_last_cmd("Help");
			show_help();
			return(irtn); }
	    if(lkey==k_af_filter_design) {
			show_last_cmd("Filter");
			filter_design_modalbox();
			return(irtn); }
	    if(lkey==k_mode_s_c || lkey==k_mode_s_l) {
			show_last_cmd("MODE");
			set_mode(2);
			return(irtn); }

	    if(lkey==k_binaural_t) {
			show_last_cmd("BINRL");
			binaural ^= 1;
			set_mode(1);		/* Separate? Probably. */
			return(irtn); }

#if 0
	    if(lkey==k_iq_t) {
			iq ^= 1;
			set_mode(1);
			return(irtn); }
#endif

	    if(lkey==k_rit_m_c || lkey==k_rit_m_l) {
			show_last_cmd("RIT-");
			if(rit_on) 
			    {
			    rit -= 10;
			    new_freq();
			    }
			return(irtn); }
	    if(lkey==k_rit_p_c || lkey==k_rit_p_l) {
			show_last_cmd("RIT+");
			if(rit_on) 
			    {
			    rit += 10;
			    new_freq();
			    }
			return(irtn); }
	    if(lkey==k_rit_m1_c || lkey==k_rit_m1_l) {
			show_last_cmd("RIT-");
			if(rit_on) 
			    {
			    rit -= 1;
			    new_freq();
			    }
			return(irtn); }
	    if(lkey==k_rit_p1_c || lkey==k_rit_p1_l) {
			show_last_cmd("RIT+");
			if(rit_on) 
			    {
			    rit += 1;
			    new_freq();
			    }
			return(irtn); }
	    if(lkey==k_rit_z_c || lkey==k_rit_z_l) {
			show_last_cmd("RIT Z");
			rit = 0;
			new_freq();
			return(irtn); }
	    if(lkey==k_rit_o_c || lkey==k_rit_o_l) {
			show_last_cmd("RIT T");
			rit_toggle();
			new_freq();
			return(irtn); }
	    if(lkey==k_af_gain_m) {
			set_afgain(-2);
			show_last_cmd("AF G-");
			return(irtn); }
	    if(lkey==k_af_gain_p) {
			show_last_cmd("AF G+");
			set_afgain(2);
			return(irtn); }
	    if(lkey==k_af_gain_m1) {
			show_last_cmd("AF G-");
			set_afgain(-1);
			return(irtn); }
	    if(lkey==k_af_gain_p1) {
			show_last_cmd("AF G+");
			set_afgain(1);
			return(irtn); }
	    if(lkey==k_dafgd) {
			set_afgain(-deldb);
			show_last_cmd("AF G-");
			return(irtn); }
	    if(lkey==k_dafgu) {
			show_last_cmd("AF G+");
			set_afgain(deldb);
			return(irtn); }
	    if(lkey==k_sh_dafgd) {
			set_afgain(-deldb_sh);
			show_last_cmd("AF G-");
			return(irtn); }
	    if(lkey==k_sh_dafgu) {
			show_last_cmd("AF G+");
			set_afgain(deldb_sh);
			return(irtn); }
	    if(lkey==k_mute) {
			if (mute) show_last_cmd("UNMUTE");
			else      show_last_cmd("MUTE");
			set_afgain(999); /* Toggle Mute */
			return(irtn); }
	    if(lkey==k_rf_gain_m) {
			show_last_cmd("RF G-");
			if (++rfgain>6) rfgain--;
			set_rfgain();
			return(irtn); }
	    if(lkey==k_rf_gain_p) {
			show_last_cmd("RF G+");
			if (--rfgain<0) rfgain++;
			set_rfgain();
			return(irtn); }
	    if(lkey==k_fm_squelch_m_c || lkey==k_fm_squelch_m_l) {
			show_last_cmd("FM SQ-");
			if (--fm_squelch<0) fm_squelch++;
			set_fm_squelch();
			return(irtn); }
	    if(lkey==k_fm_squelch_p_c || lkey==k_fm_squelch_p_l) {
			show_last_cmd("FM SQ+");
			if (++fm_squelch>99) fm_squelch--;
			set_fm_squelch();
			return(irtn); }
	    if(lkey==k_window_t_c || lkey==k_window_t_l) {
			show_last_cmd("WIN FN");
			if (++do_window>3)   do_window=0;
			set_window();
			return(irtn); }
	    if(lkey==k_fftbw_c || lkey==k_fftbw_l) {
			show_last_cmd("FT BW");
			if (mode==FM || mode==LHL7) return(irtn);
			if (++fft_bw>3)   fft_bw=0;
			set_window();
			return(irtn); }
	    if(lkey==k_af_filter_t) {
			show_last_cmd("AF FIL");
			do_af_filt ^= 1;
			set_affilt_sw();
			return(irtn); }
	    if(lkey==k_af_filter_s) {
			show_last_cmd("FIL SL");
			af_coef += 1;
			if (af_coef > 7) af_coef=0;
			set_affilt_select();
			return(irtn); }
	    if(lkey==k_fil96) {
			show_last_cmd("IF BW");
			set_if_bw(-1);		/* Toggle values */
#if 0
			/* Toggles I-Q (bit 7) & Interpolation LP filter (13)*/
			if(fft_fcn & 0X0080)   fft_fcn &= 0XDF7F;
			else fft_fcn |= 0X2080;
			set_window();

#endif
			return(irtn); }
	    if(lkey==k_denoise_t) {
			show_last_cmd("LMS");
			select_denoise();
			return(irtn); }
	    if(lkey==k_delay_t_c || lkey==k_delay_t_l) {
			show_last_cmd("STEREO");
			set_delay_right(0);
			return(irtn); }

#if 0
	    if(lkey==k_delay_m) {
			if (--delay_right<1) delay_right=1;
			set_delay_right(delay_right);
			return(irtn); }
	    if(lkey==k_delay_p) {
			if (++delay_right>10) delay_right=10;
			set_delay_right(delay_right);
			return(irtn); }
#endif
	    if(lkey==k_nc_ave_m) {
			show_last_cmd("SPC AV");
			d_noncoh = -1;
			set_noncohave(1);
			return(irtn); }
	    if(lkey==k_nc_ave_p) {
			show_last_cmd("SPC AV");
			d_noncoh = 1;
			set_noncohave(1);
			return(irtn); }
	    if(lkey==k_record_c || lkey==k_record_l) {
			show_last_cmd("RECORD");
			set_data_save();
			return(irtn); }
	    if(lkey==k_gif_c || lkey==k_gif_l) {
			show_last_cmd("SCNSAV");
			if (use_scs_box)
			    scs_modalbox();  /* Box & does gif calls */
			else
			/* Rev 3.50 Removed BMP option */
			    do_gif_file();
			return(irtn); }
	    if(lkey==k_xmt_eq_design) {
			show_last_cmd("XMT EQ");
			filter_design_modalbox_t();			
			return(irtn); }
	    if(lkey==k_cwoffset_m_l || lkey==k_cwoffset_m) {
			show_last_cmd("CW TN-");
			if (cwoffset<100 || mode!=CW) return(irtn);
			cwoffset=cwoffset-10;
			set_cwoffset();
			return(irtn); }
	    if(lkey==k_cwoffset_p_l || lkey==k_cwoffset_p) {
			show_last_cmd("CW TN+");
			if (cwoffset>=9990 || mode!=CW) return(irtn);
			cwoffset=cwoffset+10;
			set_cwoffset();
			return(irtn); }
	    if(lkey==k_denoise_m) {
			show_last_cmd("LMS-");
			if (do_LMS==1)
			    {
			    denoise_level--;
			    if (denoise_level<0)  denoise_level=0;
			    }
			else if (do_LMS == -1)
			    {
			    autonotch_level--;
			    if (autonotch_level<0)  autonotch_level=0;
			    }
			set_denoise();
			return(irtn); }
	    if(lkey==k_denoise_p) {
			show_last_cmd("LMS+");
			if (do_LMS==1)
			    {
			    denoise_level++;
			    if (denoise_level > 100)  denoise_level=100;
			    }
			else if (do_LMS == -1)
			    {
			    autonotch_level++;
			    if (autonotch_level > 100)  autonotch_level=100;
			    }
			set_denoise();
			return(irtn); }
	    if(lkey==k_agc_decay_m_l || lkey==k_agc_decay_m) {
			show_last_cmd("AGC-");
			if (mode==FM)  return(irtn);
			agc_decay--;
			if (agc_decay<0)
				agc_decay=0;
			set_agc(agc_decay);
			return(irtn); }
	    if(lkey==k_agc_decay_p_l || lkey==k_agc_decay_p) {
			show_last_cmd("AGC+");
			if (mode==FM)  return(irtn);
			agc_decay++;
			if (agc_decay>10)
				agc_decay=10;
			set_agc(agc_decay);
			return(irtn); }
#if 0
  /* Removed 21 Dec 02 */
	    if(lkey==k_bits_8_16) {
			show_last_cmd("B 8/16");
			set_8_16(1);
			return(irtn); }
#endif
	    if(lkey==k_eme_prev) {

 /*			show_last_cmd("EME L-");
			set_cur_loc(0);
 */
	wmem_modalbox();

			return(irtn); }
	    if(lkey==k_eme_next) {
			show_last_cmd("EME L+");
			set_cur_loc(1);
			return(irtn); }
	    if(lkey==k_emedop_c || lkey==k_emedop_l) {
			show_last_cmd("EME DP");
			eme_doppler = !eme_doppler;
			set_eme_doppler();
			return(irtn); }
	    if(lkey==k_code_data_c || lkey==k_code_data_l) {
			show_last_cmd("A Box");
			if (current_info_box == &lb_eme2)  /* If box open */
			   {eme2_update(0);
			   current_info_box=0;
			   return(irtn);
			   }
			else if (mode==EME2)
			   {eme2_update(1);
			   eme2_update(2);
			   current_info_box=&lb_eme2;
			   return(irtn);
			   }
			else if (current_info_box == &lb_lhl7)  /* If open */
			   {lhl7_update(0, 0);	/* Close the box */
			   return(irtn);
			   }
			else if (mode==LHL7)
			   {lhl7_update(0, 1);
			   current_info_box=&lb_lhl7;
			   return(irtn);
			   }
			else if (current_info_box == &lb_pua43)  /* If open */
			   {pua43_update(0, 0);	/* Close the box */
			   return(irtn);
			   }
			else if (mode==PUA43)
			   {pua43_update(0, 1);
			   current_info_box=&lb_pua43;
			   return(irtn);
			   }
			if (current_info_box == &lb_lterm_int)  /* If open */
			   {lterm_int_update(0);
			   current_info_box=0;
			   return(irtn);
			   }
			else if (mode==LTI)
			   {lterm_int_update(1);
			   lterm_int_update(2);
			   current_info_box=&lb_lterm_int;
			   return(irtn);
			   }
			else if (current_info_box != &lb_freq)
			    freq_data(1, 0L, 0L, 0L, 0L, 0L, 0); /* Open */
			else
			    freq_data(0, 0L, 0L, 0L, 0L, 0L, 0); /* Close */
			return(irtn); }		/* If any situation left */
	    if(lkey==k_sig_sim) {
			show_last_cmd("SigSim");
			sigsim_modalbox();
			return(irtn); }
	    if(lkey==k_beacon_box) {
			show_last_cmd("BcnBox");
			beacon_modalbox();
			return(irtn); }
	    if(lkey==k_tone_box) {
			show_last_cmd("ToneBx");
			ttn_modalbox();
			return(irtn); }
	    if(lkey==k_code_change_c || lkey==k_code_change_l) {
			show_last_cmd("B Box");
			if (mode==LHL7)
			   {lhl7_modalbox();
			   return(irtn);
			   }
			else if (mode==EME2)
			   {eme2_modalbox();
			   return(irtn);
			   }
			else if (mode==PUA43)
			   {pua43_modalbox();
			   return(irtn);
			   }
			else if (mode==LTI)
			   {lterm_int_modalbox();
			   return(irtn);
			   }
			return(irtn); }		/* All other modes */
	    if(lkey==k_clr_lt_c || lkey==k_clr_lt_l) {
			show_last_cmd("CLR LT");
			setviewport(X2L+1, Y2T+1, X2R-1, Y2B-1, DO_CLIP);
			setcolor(c_plot_bold);
			line(34, scroll_line, 36, scroll_line);
			if (mode == EME2)
			   {eme2_update(-1);	/* Zero sums */
			   paveave=0.0;
			   eme_pulse_count=0;
			   return(irtn);
			   }
			else if (mode==LTI)
			   {lterm_int_update(-1);	/* Zero sums */
			   paveave=0.0;
			   eme_pulse_count=0;
			   return(irtn);
			   }
			else if (mode == PUA43)
			   {pua43_update(0, -1); /* Zero sums */
			   return(irtn);
			   }
			else
			   return(irtn); }
	    if(lkey==k_clr_ylw_c || lkey==k_clr_ylw_l) {
			if (mode == PUA43)
			   {pua43_update(0, -4); /* Zero yellow trace */
			   show_last_cmd("ClrYlw");
			   }
			return(irtn); }
	    if(lkey==k_vcur1_c || lkey==k_vcur1_l) {
			show_last_cmd("V Cur");
			show_1cur();
			return(irtn); }
	    if(lkey==k_vcur2_c || lkey==k_vcur2_l) {
			show_last_cmd("V 2Cur");
			show_2cur();
			return(irtn); }
	    if(lkey==k_contrast_m) {
			show_last_cmd("CNTRST");
			if (--contrast<0) contrast++;
			set_contrast();
			return(irtn); }
	    if(lkey==k_contrast_p) {
			show_last_cmd("CNTRST");
			if (++contrast>100) contrast--;
			set_contrast();
			return(irtn); }
	    if(lkey==k_brite_m) {
			show_last_cmd("BRITE-");
			if (--bright<0) bright++;
			set_brightness();
			return(irtn); }
	    if(lkey==k_brite_p) {
			show_last_cmd("BRITE+");
			if (++bright>100) bright--;
			set_brightness();
			return(irtn); }
	    if(lkey==k_diag_s) {
			show_last_cmd("B LINE");
			diagnostics(0);
			return(irtn); }
	    if(lkey==k_norm_qck_c || lkey==k_norm_qck_l) {
			show_last_cmd("Q NORM");
			if (normalize_on)  normalize_plot(0);
			else               normalize_plot(1);
			return(irtn); }
	    if(lkey==k_norm_prc_c || lkey==k_norm_prc_l) {
			show_last_cmd("P NORM");
			if (normalize_on)  normalize_plot(0);
			else               normalize_plot(2);
			return(irtn); }
	    if(lkey==k_color_agc_c || lkey==k_color_agc_l) {
			show_last_cmd("A DSPL");
			if (auto_disp_on)  do_auto_disp(0);
			else               do_auto_disp(1);
			return(irtn); }
	    if(lkey==k_disp_t_c || lkey==k_disp_t_l) {
			show_last_cmd("PANEL");
			waterfall ^= 1;
			disp_toggle();
			return(irtn); }
	    if(lkey==k_offset_m) {
			show_last_cmd("OFFST-");
			koffset -= 1.0;
			if (koffset<-50.0) koffset=-50.0;
			set_disp_offset(1);
			return(irtn); }
	    if(lkey==k_offset_p) {
			show_last_cmd("OFFST+");
			koffset += 1.0;
			if (koffset>50.0) koffset=50.0;
			set_disp_offset(1);
			return(irtn); }
	    if(lkey==k_db_div) {
			show_last_cmd("DB/DIV");
			db_div_set += 1;
			if (db_div_set>3)  db_div_set=0;
			set_db_div(1);
			return(irtn); }
	    if(lkey==k_do_quit) {
			show_last_cmd("EXIT");
			irtn = exit_modalbox(); /* 0=no exit, 1=exit */
			return(irtn); }
	    if(lkey==k_set_clock_c || lkey==k_set_clock_l) {
			show_last_cmd("CLOCK");
			set_clock(1);
			return(irtn); }
	    if(lkey==k_flat_c || lkey==k_flat_l) {
			setviewport(X2L+1, Y2T+1, X2R-1, Y2B-1, DO_CLIP);
			setcolor(c_outline_bright);
			line(36, scroll_line, 38, scroll_line);
			show_last_cmd("FLATTN");
			lt_normalize();
			return(irtn); }
	    if(lkey==k_save_cfg) {
			show_last_cmd("SAVCFG");
			if(floppy_door(deflt_drv))
			    save_state();
			else
			    do_t_error(42, "E42 Floppy", 500);
			return(irtn); }
	    if(lkey==k_dos_visit) {
			call2dos();
			return(irtn); }
#if 0
	    if(lkey==k_k_sf9) {
			show_last_cmd("LMSDCY");
			denoise_decay -= 1;
			if (denoise_decay<0)  denoise_decay=0;
			set_denoise();
			return(irtn); }
#endif

	    if(lkey==k_pua_del) {
#if 0
			show_last_cmd("LMSDCY");
			denoise_decay += 1;
			if (denoise_decay > 99)  denoise_decay=99;
			set_denoise();
#endif

			show_last_cmd("43 DEL");
			pua43_delete_modalbox();
			return(irtn); }
	    if(lkey==k_band_50_a) {
		show_last_cmd("VFO A");new_vfo(0);return(irtn);}
	    if(lkey==k_band_144_b) {
		show_last_cmd("VFO B");new_vfo(1);return(irtn);}
	    if(lkey==k_band_220_c) {
		show_last_cmd("VFO C");new_vfo(2);return(irtn);}
	    if(lkey==k_band_432_d) {
		show_last_cmd("VFO D");new_vfo(3);return(irtn);}
	    if(lkey==k_band_902_9) {
		show_last_cmd("VFO 9");new_vfo(4);return(irtn);}
	    if(lkey==k_band_1296_e) {
		show_last_cmd("VFO E");new_vfo(5);return(irtn);}
	    if(lkey==k_band_2304_f) {
		show_last_cmd("VFO F");new_vfo(6);return(irtn);}
	    if(lkey==k_band_3456_g) {
		show_last_cmd("VFO G");new_vfo(7);return(irtn);}
	    if(lkey==k_band_5760_h) {
		show_last_cmd("VFO H");new_vfo(8);return(irtn);}
	    if(lkey==k_band_10k_i) {
		show_last_cmd("VFO I");new_vfo(9);return(irtn);}
	    if(lkey==k_band_24k_j) {
		show_last_cmd("VFO J");new_vfo(10);return(irtn);}
	    if(lkey==k_band_47k_k) {
		show_last_cmd("VFO K");new_vfo(11);return(irtn);}
	    if(lkey==k_band_75k_l) {
		show_last_cmd("VFO L");new_vfo(12);return(irtn);}
	    if(lkey==k_band_119k_m) {
		show_last_cmd("VFO M");new_vfo(13);return(irtn);}
	    if(lkey==k_band_145k_n) {
		show_last_cmd("VFO N");new_vfo(14);return(irtn);}
	    if(lkey==k_audio_o) {
		show_last_cmd("AUDIO");new_vfo(15);return(irtn);}
	    if(lkey==k_band_memo_1) {
		show_last_cmd("VFO 1");new_vfo(16);return(irtn);}
	    if(lkey==k_band_memo_2) {
		show_last_cmd("VFO 2");new_vfo(17);return(irtn);}
	    if(lkey==k_band_memo_3) {
		show_last_cmd("VFO 3");new_vfo(18);return(irtn);}
	    if(lkey==k_band_memo_4) {
		show_last_cmd("VFO 4");new_vfo(19);return(irtn);}
	    if(lkey==k_band_memo_5) {
		show_last_cmd("VFO 5");new_vfo(20);return(irtn);}
	    if(lkey==k_memw_c || lkey==k_memw_l){
		show_last_cmd("MEM W"); wmem_modalbox(); return(irtn);}
	    if(lkey==k_memr_c || lkey==k_memr_l){
		show_last_cmd("MEM R"); rmem_modalbox(); return(irtn);}
	    if(lkey==k_mem2vfo_c || lkey==k_mem2vfo_l){
		show_last_cmd("2 VFO"); to_vfo(); return(irtn);}
	    if(lkey==k_memlist_c || lkey==k_memlist_l){
		show_last_cmd("LIST"); um_dir(); return(irtn);}
	    }

	if (mode==CW || mode==LHL7 || mode==LTI)
	   {
	   ichr=ichr & 0XFF;
	   /* Not scrl, ctrl, alt, but either alphnumeric or Back Space */
	   if ((!(lkey & 0X1C0000)) &&
		 ((ichr>=32 && ichr<127 && ichr!='<' && ichr!='>')
			 || ichr==8))
		{
		morse(ADD_CH, ichr);
		sprintf(cc, "'%c'", ichr);
		show_last_cmd(cc);
		}
	   }
	if (mode==FM && transmit)	/* In FM attempt to send DTMF tone */
	   {
	   ichr=ichr & 0XFF;
	   dtmf(ichr);
	   }

	return(irtn);
	}

/* dtmf(idt)  -  Sends a DTMF tone pair in FM transmit. Responds to
 * idt in ASCII. '0' to '9', '*', '#', and 'A' to 'D' are allowed, others are
 * ignored.  Added Ver 3.29  26 Nov 04.            */
void dtmf(int idt)
	{
	int idtmf;			/* Index (0,15) for DTMF alphabet */
	double f1[]={941.0, 697.0, 697.0, 697.0, 770.0, 770.0, 770.0, 852.0,
		     852.0, 852.0, 941.0, 941.0, 697.0, 770.0, 852.0, 941.0};
	double f2[]={1336.0,1209.0,1336.0,1477.0,1209.0,1336.0,1477.0,1209.0,
		     1336.0,1477.0,1209.0,1477.0,1633.0,1633.0,1633.0,1633.0};
	static char sdtmf[7]="DTMF  ";

	/* See if we are doing DTMF */
	if (vfo[cur_vfo].t_fm_use != FMTONE_DTMF)  return;

	if (idt>='0' && idt<='9')
	    idtmf = idt-'0';		/* 0 to 9  */
	else if (idt=='*')
	    idtmf = 10;
	else if (idt=='#')
	    idtmf = 11;
	else if (idt>='A' && idt<='D')
	    idtmf = idt-53;		/* 'A' is 12,...,'D' is 15 */
	else if (idt>='a' && idt<='d')
	    idtmf = idt-85;		/* 'a' is 12,...,'d' is 15 */
	else
	    return;			/* Nothing fits */

	sdtmf[5]=(char)idt;
	show_last_cmd(sdtmf);
	ttn_freq1=f1[idtmf];		/* Frequencies from table */
	ttn_level1=dtmf_level;		/* Levels from .CFG file */
	ttn_freq2=f2[idtmf];
	ttn_level2=dtmf_level;
	set_ttn(2);			/* Sets DSP freqs and levels */
	ttn_control=3;  set_ttn(1);	/* Tones on, voice off */
	delay(dtmf_length);		/* Typically 100 ms */
	ttn_control=4;  set_ttn(1);	/* Returns to voice only */
	delay(20);
	return;
	}
